#! /usr/bin/env Rscript

C <- c("CoreLength5","CoreLength10","CoreLength20","CoreLength50","CoreLength100")

## Set core and breed working directory
WD <- getwd()

DirBreed  <- getwd()
BaseBreed <- basename(getwd())

setwd(WD)

## Read in the map file
Map        <- read.table(file=paste0("/home/jjenko/Hpc/Illumina/Janez/Analysis_Purebreds_LmChAaSiHe/GenotypesQualityCheck/", BaseBreed, "/AllChipsFinal.map"), header=FALSE, stringsAsFactors=FALSE)
names(Map) <- c("Chr", "Snp", "PhysicalPos", "BasepairPos")

## Read in the core length. Do this so that for each HapLibxx.txt length of the string is counted
DataCumulative <- data.frame()
HapString      <- data.frame()
for (c in C) {
  print (c)
  HapStringTmp <- data.frame()
  for (i in c(1:29)) {
    HapWD <- paste0("/home/jjenko/Hpc/Illumina/Janez/Analysis_Purebreds_LmChAaSiHe/Chromosomes/", BaseBreed, "/Chromosome", i ,"/Phasing/Phasing", c, "/PhasingResults/HaplotypeLibrary")
    setwd(HapWD)
    HapLibs <- dir() 
    for (j in HapLibs) {
      tmp          <- paste0("head -1 ", j, " | awk \'{print $3}\'")
      tmp1         <- system(tmp, intern = TRUE)
      tmp2         <- data.frame(c, i, j, nchar(tmp1))
      HapStringTmp <- rbind(HapStringTmp, tmp2)
    }
  }

  names(HapStringTmp) <- c("CoreLength", "Chromosome", "HaploLib", "Bases")
  HapStringTmp        <- HapStringTmp[order(HapStringTmp$CoreLength, HapStringTmp$Chromosome, as.numeric(gsub("[^0-9]", "", HapStringTmp$HaploLib))), ]

  ## Add the information about the SNP location
  HapStringTmp$StartSnp       <- NA
  HapStringTmp$EndSnp         <- NA
  HapStringTmp[1 ,"StartSnp"] <- 1
  HapStringTmp[1 ,"EndSnp"]   <- HapStringTmp[1 ,"Bases"]
  for (i in 2:nrow(HapStringTmp)) {
    HapStringTmp[i, "StartSnp"] <- HapStringTmp[i ,"Bases"] + HapStringTmp[i-1 ,"StartSnp"]
    HapStringTmp[i, "EndSnp"]   <- HapStringTmp[i ,"Bases"] + HapStringTmp[i-1 ,"EndSnp"]
  }

  HapStringTmp$StartBase       <- NA
  HapStringTmp$EndBase         <- NA
  for (i in 1:nrow(HapStringTmp)) {
    HapStringTmp[i, "StartBase"] <- Map[HapStringTmp[i, "StartSnp"], "BasepairPos"]
    HapStringTmp[i, "EndBase"]   <- Map[HapStringTmp[i, "EndSnp"], "BasepairPos"]
  }

  HapStringTmp$Region <- NA 
  for (i in c(1:nrow(HapStringTmp))) {
    HapStringTmp[i, "Region"] <- round(((HapStringTmp[i, "EndBase"] - HapStringTmp[i, "StartBase"]) / 2 + HapStringTmp[i, "StartBase"]), 0)
  }
  HapString <- rbind(HapString, HapStringTmp)

  setwd(WD)

  ## Read in the results from different scenarios and place haplotypes on the chromosomes
  DataCumulativeTmp <- data.frame()
  for (i in c("VR1.txt", "BinomialSireDam.txt", "BinomialSireMgs.txt", "ChiSquareSireDam.txt", "ChiSquareSireMgs.txt", "VR2BernoulliSireDam.txt", "VR2BernoulliSireMgs.txt", "Howard1b.txt", "Howard1c.txt")) {
    Data <- read.table(file=paste0(c, "/LethalCandidatesVanRadenHoward/", i), header=TRUE, stringsAsFactors=FALSE)
    if (nrow(Data) > 0) {
      if (i %in% c("VR1.txt")) {
        Data <- Data[,c("Chromosome", "HaploLib", "HaploID", "HaploNum", "ProbOfNoHomozVR1")]
        Data$Method <- i
      }
      if (i %in% c("VR1HaploWithFreq2orMorePerc.txt")) {
        Data <- Data[,c("Chromosome", "HaploLib", "HaploID", "HaploNum", "ProbOfNoHomozVR1")]
        Data$Method <- i
      }
      if (i %in% c("VR2BernoulliSireDam.txt")) {
        Data <- Data[,c("Chromosome", "HaploLib", "HaploID", "HaploNum", "ProbOfNoHomozVR2IdSireDamChr")]
        Data$Method <- i
      }
      if (i %in% c("VR2BernoulliSireMgs.txt")) {
        Data <- Data[,c("Chromosome", "HaploLib", "HaploID", "HaploNum", "ProbOfNoHomozVR2IdSireMgsChr")]
        Data$Method <- i
      }
      if (i %in% c("ChiSquareSireDam.txt", "BinomialSireDam.txt")) {
        Data <- Data[,c("Chromosome", "HaploLib", "HaploID", "HaploNum", "ChiSquareStatisticsSireDamPvalue")]
        Data$Method <- i
      }
      if (i %in% c("ChiSquareSireMgs.txt", "BinomialSireMgs.txt")) {
        Data <- Data[,c("Chromosome", "HaploLib", "HaploID", "HaploNum", "ChiSquareStatisticsSireMgsPvalue")]
        Data$Method <- i
      }
      if (i %in% c("Howard1b.txt")) {
        Data        <- Data[,c("Chr", "Core", "HapId", "ProbOfNoHomozygous")]
        Data$HapLib <- paste0("HapLib", Data$Core, ".txt")
        Data$HapNum <- NA
        Data        <- Data[,c("Chr", "HapLib", "HapId", "HapNum", "ProbOfNoHomozygous")]
        Data$Method <- i
      }
      if (i %in% c("Howard1c.txt")) {
        Data        <- Data[,c("Chr", "Core", "HapId", "HapNum", "ProbOfNoHomozygous")]
        Data$HapLib <- paste0("HapLib", Data$Core, ".txt")
        Data        <- Data[,c("Chr", "HapLib", "HapId", "HapNum", "ProbOfNoHomozygous")]
        Data$Method <- i
      }  
      names(Data)       <- c("Chromosome", "HaploLib", "HaploID", "HaploNum", "Pvalue", "Method")
      Data$CoreLength   <- c
      DataCumulativeTmp <- rbind(DataCumulativeTmp, Data)
    }
  }
  DataCumulative <- rbind(DataCumulative, DataCumulativeTmp)
}

## Add information about location for each haplotype
DataCumulative <- merge(DataCumulative, HapString, by=c("Chromosome", "HaploLib", "CoreLength"))

## For the ChisSquare test use the signigicance of 1.110223e-16 for all the matings with ChiSquare statistics more than 70.1303. This is because above this value the test statistics gives them 0
DataCumulative[DataCumulative$Pvalue == 0 & (DataCumulative$Method == "ChiSquareSireDam.txt" | DataCumulative$Method == "ChiSquareSireMgs.txt"), "Pvalue"] <- 1.110223e-16

## This will remove Binomial testst that were not included in the paper and have p value equal to 0
DataCumulative <- DataCumulative[DataCumulative$Pvalue > 0,]

################################################################################################################################################################################
## This is a part for detecting carrier animals for genotyping 
################################################################################################################################################################################

## Load libraries
library(rvest)
library(stringr)

## Extract SNPs with significance less than 5*10^(-8)
DataCumulativeSignificant                       <- DataCumulative[DataCumulative$Pvalue < 5*10^(-8), ]
DataCumulativeSignificant$CompletelyOverlapping <- 0
DataCumulativeSignificant$PartiallyOverlapping  <- 0
DataCumulativeSignificant$PopulationMethod      <- 0
DataCumulativeSignificant$MatingMethod          <- 0
DataCumulativeSignificant$CompletelyLethal      <- 0
DataCumulativeSignificant$ConditionallyLethal   <- 0

## Exclude all significant hits when using Binomial method
DataCumulativeSignificant <- DataCumulativeSignificant[!(DataCumulativeSignificant$Method %in% c("BinomialSireDam.txt", "BinomialSireMgs.txt")), ]

for (i in 1 : nrow(DataCumulativeSignificant)) {
  if (DataCumulativeSignificant[i ,"Method"] == "VR1.txt") {
    DataCumulativeSignificant[i ,"PopulationMethod"] <- DataCumulativeSignificant[i ,"PopulationMethod"] + 1
  } else  {
    DataCumulativeSignificant[i ,"MatingMethod"] <- DataCumulativeSignificant[i ,"MatingMethod"] + 1
  }
  if (DataCumulativeSignificant[i ,"Method"] %in% c("ChiSquareSireDam.txt","ChiSquareSireMgs.txt")) {
    DataCumulativeSignificant[i ,"ConditionallyLethal"] <- DataCumulativeSignificant[i ,"ConditionallyLethal"] + 1
  } else {
    DataCumulativeSignificant[i ,"CompletelyLethal"] <- DataCumulativeSignificant[i ,"CompletelyLethal"] + 1
  }
  for (j in 1 : nrow(DataCumulativeSignificant)) {
    if (i!=j &
        DataCumulativeSignificant[i ,"Chromosome"] == DataCumulativeSignificant[j ,"Chromosome"] &
        DataCumulativeSignificant[i ,"StartBase"] >= DataCumulativeSignificant[j ,"StartBase"] & 
        DataCumulativeSignificant[i ,"EndBase"] <= DataCumulativeSignificant[j ,"EndBase"]
        ) {
      DataCumulativeSignificant[i ,"CompletelyOverlapping"] <- DataCumulativeSignificant[i ,"CompletelyOverlapping"] + 1
      if (DataCumulativeSignificant[j ,"Method"] == "VR1.txt") {
        DataCumulativeSignificant[i ,"PopulationMethod"] <- DataCumulativeSignificant[i ,"PopulationMethod"] + 1
      } else  {
        DataCumulativeSignificant[i ,"MatingMethod"] <- DataCumulativeSignificant[i ,"MatingMethod"] + 1
      }
      if (DataCumulativeSignificant[j ,"Method"] %in% c("ChiSquareSireDam.txt","ChiSquareSireMgs.txt")) {
        DataCumulativeSignificant[i ,"ConditionallyLethal"] <- DataCumulativeSignificant[i ,"ConditionallyLethal"] + 1
      } else {
        DataCumulativeSignificant[i ,"CompletelyLethal"] <- DataCumulativeSignificant[i ,"CompletelyLethal"] + 1
      }
    }
    if (i!=j &
        DataCumulativeSignificant[i ,"Chromosome"] == DataCumulativeSignificant[j ,"Chromosome"] & (
        (DataCumulativeSignificant[i ,"StartBase"] >= DataCumulativeSignificant[j ,"StartBase"] & DataCumulativeSignificant[i ,"StartBase"] < DataCumulativeSignificant[j ,"EndBase"] & DataCumulativeSignificant[i ,"EndBase"] >  DataCumulativeSignificant[j ,"StartBase"] & DataCumulativeSignificant[i ,"EndBase"] >  DataCumulativeSignificant[j ,"EndBase"]) | 
        (DataCumulativeSignificant[i ,"StartBase"] <  DataCumulativeSignificant[j ,"StartBase"] & DataCumulativeSignificant[i ,"StartBase"] < DataCumulativeSignificant[j ,"EndBase"] & DataCumulativeSignificant[i ,"EndBase"] >  DataCumulativeSignificant[j ,"StartBase"] & DataCumulativeSignificant[i ,"EndBase"] <= DataCumulativeSignificant[j ,"EndBase"]) |
        (DataCumulativeSignificant[i ,"StartBase"] <  DataCumulativeSignificant[j ,"StartBase"] & DataCumulativeSignificant[i ,"StartBase"] < DataCumulativeSignificant[j ,"EndBase"] & DataCumulativeSignificant[i ,"EndBase"] >  DataCumulativeSignificant[j ,"StartBase"] & DataCumulativeSignificant[i ,"EndBase"] > DataCumulativeSignificant[j ,"EndBase"]))          
        ) {
      DataCumulativeSignificant[i ,"PartiallyOverlapping"] <- DataCumulativeSignificant[i ,"PartiallyOverlapping"] + 1
      if (DataCumulativeSignificant[j ,"Method"] == "VR1.txt") {
        DataCumulativeSignificant[i ,"PopulationMethod"] <- DataCumulativeSignificant[i ,"PopulationMethod"] + 1
      } else  {
        DataCumulativeSignificant[i ,"MatingMethod"] <- DataCumulativeSignificant[i ,"MatingMethod"] + 1
      }
      if (DataCumulativeSignificant[j ,"Method"] %in% c("ChiSquareSireDam.txt","ChiSquareSireMgs.txt")) {
        DataCumulativeSignificant[i ,"ConditionallyLethal"] <- DataCumulativeSignificant[i ,"ConditionallyLethal"] + 1
      } else {
        DataCumulativeSignificant[i ,"CompletelyLethal"] <- DataCumulativeSignificant[i ,"CompletelyLethal"] + 1
      }
    }
  }
}

DataCumulativeSignificantDistinct       <- unique(DataCumulativeSignificant[,c("Chromosome","HaploLib","CoreLength","HaploID")])

###################################################################################################################################################################################################
## Find carriers from the pedigree with the most of these haplotypes
Pedig                 <- read.table(file=paste0("/home/jjenko/Hpc/Illumina/Janez/Analysis_Purebreds_LmChAaSiHe/Pedigree/", BaseBreed, "/AlphaRecodedPedigree.txt"), header=FALSE, stringsAsFactors=FALSE)
BirthDates            <- read.csv(file="/home/jjenko/Hpc/Illumina/Janez/BirthDates/AnimalsID_birth_death_dates.csv", header=TRUE, stringsAsFactors=FALSE)
NumOfProgenyPerParent <- data.frame(table(c(t(Pedig[,c(2,3)]))))

## For each putative lethal extract animals that have at least 50 purebred genotyped progeny
CandidateAnimals <- data.frame()
for (i in 1:nrow(DataCumulativeSignificantDistinct)) {
  Chr              <- DataCumulativeSignificantDistinct[i, "Chromosome"]
  CoreLength       <- DataCumulativeSignificantDistinct[i, "CoreLength"]
  FinalHapIndCarry <- read.table(file=paste0("/home/jjenko/Hpc/Illumina/Janez/Analysis_Purebreds_LmChAaSiHe/Chromosomes/", BaseBreed ,"/Chromosome", Chr, "/Phasing/Phasing", CoreLength, "/PhasingResults/FinalHapIndCarry.txt"), header=FALSE, stringsAsFactors=FALSE)
  HapLib           <- as.numeric(gsub("[[:alpha:]]", "", DataCumulativeSignificantDistinct[i, "HaploLib"]))
  FinalHapIndCarry <- FinalHapIndCarry[, c(1, (HapLib*2):(HapLib*2+1))]
  HaploID          <- DataCumulativeSignificantDistinct[i, "HaploID"]
  FinalHapIndCarry <- FinalHapIndCarry[FinalHapIndCarry[,2] %in% HaploID | FinalHapIndCarry[,3] %in% HaploID, ]
#  FinalHapIndCarry <- FinalHapIndCarry[!(FinalHapIndCarry[,2] %in% HaploID) & !(FinalHapIndCarry[,3] %in% HaploID), ]
  FinalHapIndCarry <- FinalHapIndCarry[FinalHapIndCarry[,2] != FinalHapIndCarry[,3], ]
  Candidates       <- NumOfProgenyPerParent[NumOfProgenyPerParent[, "Var1"] %in% FinalHapIndCarry[, "V1"] & NumOfProgenyPerParent[, "Freq"] >= 50, ]
  Candidates       <- merge(BirthDates, Candidates, by.x="ani_id", by.y="Var1")
  if (nrow(Candidates) > 0) {
    for (j in 1:nrow(Candidates)) {
      url              <- paste0("https://webapp.icbf.com/bull-search/view-beef-extra-calv-int/", Candidates[j, "ani_id"])
      webpage          <- read_html(url)
      dbc_table        <- html_nodes(webpage, 'table')
      dbc_bv           <- html_table(dbc_table, fill=TRUE)[[1]]
      bv               <- data.frame(dbc_bv[1,c("Percentile Rank within breed", "PTA", "Reliability", "Percentile Rank across Breed")])
      dbc_pheno        <- html_table(dbc_table, fill=TRUE)[[2]]
      pheno            <- data.frame(dbc_pheno[2,])
      names(pheno)      <- dbc_pheno[1,]
      tmp              <- cbind(Candidates[j,], pheno, bv, DataCumulativeSignificantDistinct[i,])
      CandidateAnimals <- rbind(CandidateAnimals, tmp)    
    }
  }
}

sink(file = "SummaryLethal.txt", append = FALSE)
#################################################################################################################################################################################################
## Summary statistics
#################################################################################################################################################################################################
## Count the number of animals with at least 50 genotyped progeny
cat("Number of animals with at least 50 genotyped progeny", "\n")
cat(nrow(NumOfProgenyPerParent[NumOfProgenyPerParent$Freq >= 50 & NumOfProgenyPerParent$Var1 != 0, ]),"\n\n")

## Count the number of animals with at least 50 genotyped progeny and at least one putative lethal haplotype
cat("Number of animals with at least 50 genotyped progeny and at least one putative lethal haplotype", "\n")
cat(length(unique(CandidateAnimals$ani_id)),"\n\n")

## Count the number of distinct haplotypes with at least one significant method
cat("Number of haplotypes with at least one significant method", "\n")
cat(nrow(DataCumulativeSignificantDistinct),"\n\n")

write.table(DataCumulativeSignificantDistinct, file="HaplotypesWithAtLeastOneSignificantMethod.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

#################################################################################################################################################################################################
## Think what to do with this statistics!!!
#CandidateAnimalsCi <- unique(CandidateAnimals[, c("ani_id", "No. of Progeny", "No. of Herdmates", "Average Daughter", "Average Herdmate")])
#CandidateAnimalsCi[ ,"No. of Progeny"]   <- as.numeric(CandidateAnimalsCi[ ,"No. of Progeny"])
#CandidateAnimalsCi[ ,"No. of Herdmates"] <- as.numeric(CandidateAnimalsCi[ ,"No. of Herdmates"])
#CandidateAnimalsCi[ ,"Average Daughter"] <- as.numeric(CandidateAnimalsCi[ ,"Average Daughter"])
#CandidateAnimalsCi[ ,"Average Herdmate"] <- as.numeric(CandidateAnimalsCi[ ,"Average Herdmate"])
#CandidateAnimalsCi$AverageDifference     <- CandidateAnimalsCi[, "Average Daughter"] - CandidateAnimalsCi[, "Average Herdmate"]
#CandidateAnimalsCi$CummulativeDifference <- CandidateAnimalsCi$AverageDifference * CandidateAnimalsCi[, "No. of Progeny"]

#min(CandidateAnimalsCi$CummulativeDifference, na.rm=T)
#max(CandidateAnimalsCi$CummulativeDifference, na.rm=T)
#sum(CandidateAnimalsCi$CummulativeDifference, na.rm=T)
#################################################################################################################################################################################################


## ## Count the number of distinct haplotypes with population method (VR1) and at least one mating method significant (all the rest methods)
## DataCumulativeSignificantPopMating      <- unique(DataCumulativeSignificant[DataCumulativeSignificant$PopulationMethod > 0 & DataCumulativeSignificant$MatingMethod > 0, c("Chromosome","HaploLib","CoreLength","HaploID")])
## cat("Number of distinct haplotypes with population method (VR1) and at least one mating method significant (all the rest methods)", "\n")
## cat(nrow(DataCumulativeSignificantPopMating), "\n\n")
## write.table(DataCumulativeSignificantPopMating, file="HaplotypesWithPopAndMatingSignificantMethod.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

## ## Count the number of distinct haplotypes with complete lethality (The significance was observed with Howard1b, Howard1c, VR2BernoulliSireMgs, VR2BernoulliSireDam)
## DataCumulativeSignificantCompleteLethal <- unique(DataCumulativeSignificant[DataCumulativeSignificant$Method %in% c("Howard1b", "Howard1c", "VR2BernoulliSireMgs", "VR2BernoulliSireDam"), c("Chromosome","HaploLib","CoreLength","HaploID")])
## cat("Number of distinct haplotypes with complete lethality (The significance was observed with Howard1b, Howard1c, VR2BernoulliSireMgs, VR2BernoulliSireDam)", "\n")
## cat(nrow(DataCumulativeSignificantCompleteLethal), "\n\n")
## write.table(DataCumulativeSignificantCompleteLethal, file="HaplotypesWithCompleteLethality.txt", col.names=TRUE, row.names=FALSE, quote=FALSE)

## ## Count the number of distinct haplotypes with conditional lethality (There are some homozygous progeny but less than expected)
## DataCumulativeSignificantCondLethal     <- unique(DataCumulativeSignificant[DataCumulativeSignificant$CompletelyLethal == 0 & DataCumulativeSignificant$ConditionallyLethal > 0, c("Chromosome","HaploLib","CoreLength","HaploID")])
## cat("Number of distinct haplotypes with conditional lethality (There are some homozygous progeny but less than expected)")
## cat(nrow(unique(DataCumulativeSignificantCondLethal[,])), "\n\n")
## write.table(DataCumulativeSignificantCondLethal, file="HaplotypesWithConditionalLethality.txt", col.names=TRUE, row.names=FALSE, quote=FALSE)


#################################################################################################################################################################################################
## Selecting sires that are candidates for sequencing based on different approaches
#################################################################################################################################################################################################
## Approach 1
## Extract animals with breeding values reliability > 60% and breeding values with percentile rank within breed < 10 and check which significant haplotypes they carry
AnimalsToSequenceApp1 <- CandidateAnimals[CandidateAnimals$Percentile.Rank.within.breed < 10 & CandidateAnimals$"No. of Progeny" > 100, ]
cat("Number of animals for sequencing using approach 1", "\n")
cat(length(unique(AnimalsToSequenceApp1$ani_id)),"\n\n")
cat("Number of significant haplotypes for sequencing using approach 1", "\n")
cat(nrow(unique(AnimalsToSequenceApp1[,c("Chromosome","HaploLib","CoreLength","HaploID")])),"\n\n")
write.table(AnimalsToSequenceApp1, file="AnimalsToSequenceApp1.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

## For haplotypes that are going to be sequenced check with which method they were detected
HaploToSequenceApp1   <- merge(DataCumulativeSignificant, unique(AnimalsToSequenceApp1[, c("Chromosome", "HaploLib", "CoreLength", "HaploID")]), by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
write.table(HaploToSequenceApp1, file="HaploToSequenceApp1.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")


################################################################################################################################################################################pproach 2
## Extract animals that cary haplotype which was fund significant with population method (VR1) and at least one mating method
DataCumulativeSignificantPopMating <- unique(DataCumulativeSignificant[DataCumulativeSignificant$PopulationMethod > 0 & DataCumulativeSignificant$MatingMethod > 0, c("Chromosome","HaploLib","CoreLength","HaploID")])
AnimalsToSequenceApp2 <- merge(CandidateAnimals, DataCumulativeSignificantPopMating, by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
cat("Number of animals for sequencing using approach 2", "\n")
cat(length(unique(AnimalsToSequenceApp2$ani_id)),"\n\n")
cat("Number of significant haplotypes for sequencing using approach 2", "\n")
cat(nrow(unique(AnimalsToSequenceApp2[,c("Chromosome","HaploLib","CoreLength","HaploID")])),"\n\n")
write.table(AnimalsToSequenceApp2, file="AnimalsToSequenceApp2.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

## For haplotypes that are going to be sequenced check with which method they were detected
HaploToSequenceApp2   <- merge(DataCumulativeSignificant, unique(AnimalsToSequenceApp2[, c("Chromosome", "HaploLib", "CoreLength", "HaploID")]), by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
write.table(HaploToSequenceApp2, file="HaploToSequenceApp2.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

#################################################################################################################################################################################################
## Approach 3
## Extract animals that carry haplotype with the highest significancy
MaxSignificancy              <- min(DataCumulativeSignificant$Pvalue)
DataCumulativeSignificantMax <- DataCumulativeSignificant[DataCumulativeSignificant$Pvalue == MaxSignificancy, ]
AnimalsToSequenceApp3        <- merge(CandidateAnimals, DataCumulativeSignificantMax, by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
cat("Number of animals for sequencing using approach 3", "\n")
cat(length(unique(AnimalsToSequenceApp3$ani_id)),"\n\n")
cat("Number of significant haplotypes for sequencing using approach 3", "\n")
cat(nrow(unique(AnimalsToSequenceApp3[,c("Chromosome","HaploLib","CoreLength","HaploID")])),"\n\n")
write.table(AnimalsToSequenceApp3, file="AnimalsToSequenceApp3.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

## For haplotypes that are going to be sequenced check with which method they were detected
HaploToSequenceApp3          <- merge(DataCumulativeSignificant, unique(AnimalsToSequenceApp3[, c("Chromosome", "HaploLib", "CoreLength", "HaploID")]), by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
write.table(HaploToSequenceApp3, file="HaploToSequenceApp3.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

#################################################################################################################################################################################################
## Approach 4
## Extract animals that carry haplotypes with the highest number of completely and partially overlapping haplotypes
MaxOverlapping                          <- max(DataCumulativeSignificant$CompletelyOverlapping + DataCumulativeSignificant$PartiallyOverlapping)
DataCumulativeSignificantMaxOverlapping <- DataCumulativeSignificant[(DataCumulativeSignificant$CompletelyOverlapping + DataCumulativeSignificant$PartiallyOverlapping) == MaxOverlapping,]
AnimalsToSequenceApp4                   <- merge(CandidateAnimals, DataCumulativeSignificantMaxOverlapping, by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
cat("Number of animals for sequencing using approach 4", "\n")
cat(length(unique(AnimalsToSequenceApp4$ani_id)),"\n\n")
cat("Number of significant haplotypes for sequencing using approach 4", "\n")
cat(nrow(unique(AnimalsToSequenceApp4[,c("Chromosome","HaploLib","CoreLength","HaploID")])),"\n\n")
write.table(AnimalsToSequenceApp4, file="AnimalsToSequenceApp4.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

## For haplotypes that are going to be sequenced check with which method they were detected
HaploToSequenceApp4                     <- merge(DataCumulativeSignificant, unique(AnimalsToSequenceApp3[, c("Chromosome", "HaploLib", "CoreLength", "HaploID")]), by=c("Chromosome", "HaploLib", "CoreLength", "HaploID"))
write.table(HaploToSequenceApp4, file="HaploToSequenceApp4.txt", col.names=TRUE, row.names=FALSE, quote=FALSE, sep="\t")

sink()

## For presenting different regions I was using code from: http://genome.sph.umich.edu/wiki/Code_Sample:_Generating_Manhattan_Plots_in_R
################################################################################################################################################################################

## Manhattan plotting function
library(lattice)
manhattan.plot<-function(chr, pos, pvalue, 
  sig.level=NA, annotate=NULL, ann.default=list(),
  should.thin=T, thin.pos.places=2, thin.logp.places=2, 
  xlab="Chromosome", ylab=expression(-log[10](p-value)),
  col=c("gray","darkgray"), panel.extra=NULL, pch=20, cex=0.8,
  cex.lab=1,...) {

  if (length(chr)==0) stop("chromosome vector is empty")
  if (length(pos)==0) stop("position vector is empty")
  if (length(pvalue)==0) stop("pvalue vector is empty")

  #make sure we have an ordered factor
  if(!is.ordered(chr)) {
    chr <- ordered(chr)
  } else {
    chr <- chr[,drop=T]
  }

  #make sure positions are in kbp
  if (any(pos>1e6)) pos<-pos/1e6;

  #calculate absolute genomic position
  #from relative chromosomal positions
  posmin <- tapply(pos,chr, min);
  posmax <- tapply(pos,chr, max);
  posshift <- head(c(0,cumsum(posmax)),-1);
  names(posshift) <- levels(chr)
  genpos <- pos + posshift[chr];
  getGenPos<-function(cchr, cpos) {
    p<-posshift[as.character(cchr)]+cpos
    return(p)
  }

  #parse annotations
  grp <- NULL
  ann.settings <- list()
  label.default<-list(x="peak",y="peak",adj=NULL, pos=3, offset=0.5, 
    col=NULL, fontface=NULL, fontsize=NULL, show=F)
  parse.label<-function(rawval, groupname) {
    r<-list(text=groupname)
    if(is.logical(rawval)) {
      if(!rawval) {r$show <- F}
    } else if (is.character(rawval) || is.expression(rawval)) {
      if(nchar(rawval)>=1) {
        r$text <- rawval
      }
    } else if (is.list(rawval)) {
      r <- modifyList(r, rawval)
    }
    return(r)
  }

  if(!is.null(annotate)) {
    if (is.list(annotate)) {
      grp <- annotate[[1]]
    } else {
      grp <- annotate
    } 
    if (!is.factor(grp)) {
      grp <- factor(grp)
    }
  } else {
    grp <- factor(rep(1, times=length(pvalue)))
  }
  
  ann.settings<-vector("list", length(levels(grp)))
  ann.settings[[1]]<-list(pch=pch, col=col, cex=cex, fill=col, label=label.default)

  if (length(ann.settings)>1) { 
    lcols<-trellis.par.get("superpose.symbol")$col 
    lfills<-trellis.par.get("superpose.symbol")$fill
    for(i in 2:length(levels(grp))) {
      ann.settings[[i]]<-list(pch=pch, 
        col=lcols[(i-2) %% length(lcols) +1 ], 
        fill=lfills[(i-2) %% length(lfills) +1 ], 
        cex=cex, label=label.default);
      ann.settings[[i]]$label$show <- T
    }
    names(ann.settings)<-levels(grp)
  }
  for(i in 1:length(ann.settings)) {
    if (i>1) {ann.settings[[i]] <- modifyList(ann.settings[[i]], ann.default)}
    ann.settings[[i]]$label <- modifyList(ann.settings[[i]]$label, 
      parse.label(ann.settings[[i]]$label, levels(grp)[i]))
  }
  if(is.list(annotate) && length(annotate)>1) {
    user.cols <- 2:length(annotate)
    ann.cols <- c()
    if(!is.null(names(annotate[-1])) && all(names(annotate[-1])!="")) {
      ann.cols<-match(names(annotate)[-1], names(ann.settings))
    } else {
      ann.cols<-user.cols-1
    }
    for(i in seq_along(user.cols)) {
      if(!is.null(annotate[[user.cols[i]]]$label)) {
        annotate[[user.cols[i]]]$label<-parse.label(annotate[[user.cols[i]]]$label, 
          levels(grp)[ann.cols[i]])
      }
      ann.settings[[ann.cols[i]]]<-modifyList(ann.settings[[ann.cols[i]]], 
        annotate[[user.cols[i]]])
    }
  }
  rm(annotate)

  #reduce number of points plotted
  if(should.thin) {
    thinned <- unique(data.frame(
      logp=round(-log10(pvalue),thin.logp.places), 
      pos=round(genpos,thin.pos.places), 
      chr=chr,
      grp=grp)
    )
    logp <- thinned$logp
    genpos <- thinned$pos
    chr <- thinned$chr
    grp <- thinned$grp
    rm(thinned)
  } else {
    logp <- -log10(pvalue)
  }
  rm(pos, pvalue)
  gc()

  #custom axis to print chromosome names
  axis.chr <- function(side,...) {
    if(side=="bottom") {
      panel.axis(side=side, outside=T,
        at=((posmax+posmin)/2+posshift),
        labels=levels(chr), 
        ticks=F, rot=0,
        check.overlap=F
      )
    } else if (side=="top" || side=="right") {
      panel.axis(side=side, draw.labels=F, ticks=F);
    }
    else {
      axis.default(side=side,...);
    }
   }

  #make sure the y-lim covers the range (plus a bit more to look nice)
  prepanel.chr<-function(x,y,...) { 
    A<-list();
    maxy<-ceiling(max(y, ifelse(!is.na(sig.level), -log10(sig.level), 0)))+.5;
    A$ylim=c(0,maxy);
    A;
  }

  xyplot(logp~genpos, chr=chr, groups=grp,
    axis=axis.chr, ann.settings=ann.settings, 
    prepanel=prepanel.chr, scales=list(axs="i"),
    panel=function(x, y, ..., getgenpos) {
      if(!is.na(sig.level)) {
        #add significance line (if requested)
        panel.abline(h=-log10(sig.level), lty=2);
      }
      panel.superpose(x, y, ..., getgenpos=getgenpos);
      if(!is.null(panel.extra)) {
        panel.extra(x,y, getgenpos, ...)
      }
    },
    panel.groups = function(x,y,..., subscripts, group.number) {
      A<-list(...)
      #allow for different annotation settings
      gs <- ann.settings[[group.number]]
      A$col.symbol <- gs$col[(as.numeric(chr[subscripts])-1) %% length(gs$col) + 1]    
      A$cex <- gs$cex[(as.numeric(chr[subscripts])-1) %% length(gs$cex) + 1]
      A$pch <- gs$pch[(as.numeric(chr[subscripts])-1) %% length(gs$pch) + 1]
# I have replaced the next line since using the fill colors are a bit different
#      A$fill <- gs$fill[(as.numeric(chr[subscripts])-1) %% length(gs$fill) + 1]
      A$fill <- gs$col[(as.numeric(chr[subscripts])-1) %% length(gs$col) + 1]
      A$x <- x
      A$y <- y
      do.call("panel.xyplot", A)
      #draw labels (if requested)
      if(gs$label$show) {
        gt<-gs$label
        names(gt)[which(names(gt)=="text")]<-"labels"
        gt$show<-NULL
        if(is.character(gt$x) | is.character(gt$y)) {
          peak = which.max(y)
          center = mean(range(x))
          if (is.character(gt$x)) {
            if(gt$x=="peak") {gt$x<-x[peak]}
            if(gt$x=="center") {gt$x<-center}
          }
          if (is.character(gt$y)) {
            if(gt$y=="peak") {gt$y<-y[peak]}
          }
        }
        if(is.list(gt$x)) {
          gt$x<-A$getgenpos(gt$x[[1]],gt$x[[2]])
        }
        do.call("panel.text", gt)
      }
    },
    xlab=list(label=xlab, cex=cex.lab), ylab=list(label=ylab, cex=cex.lab), 
    panel.extra=panel.extra, getgenpos=getGenPos, ...
  );
}


## Make annotation factor
ann                                                                                        <- rep(1, length(DataCumulative$Pvalue))
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength5")]                   <- 2
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength5")]   <- 3
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength5")]   <- 4
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength5")]      <- 5
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength5")]      <- 6
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength5")]              <- 7
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength5")]              <- 8
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength10")]                  <- 9
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength10")]  <- 10
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength10")]  <- 11
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength10")]     <- 12
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength10")]     <- 13
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength10")]             <- 14
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength10")]             <- 15
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength20")]                  <- 16
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength20")]  <- 17
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength20")]  <- 18
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength20")]     <- 19
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength20")]     <- 20
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength20")]             <- 21
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength20")]             <- 22
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength50")]                  <- 23
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength50")]  <- 24
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength50")]  <- 25
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength50")]     <- 26
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength50")]     <- 27
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength50")]             <- 28
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength50")]             <- 29
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength100")]                 <- 30
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength100")] <- 31
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength100")] <- 32
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength100")]    <- 33
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength100")]    <- 34
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength100")]            <- 35
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength100")]            <- 36
ann <- factor(ann, levels=1:36, labels=c("",
       "VR1 C5",   "VR2BernoulliSireMgs C5",   "VR2BernoulliSireDam C5",   "ChiSquareSireMgs C5",   "ChiSquareSireDam C5",   "Howard1b C5",   "Howard1c C5",
       "VR1 C10",  "VR2BernoulliSireMgs C10",  "VR2BernoulliSireDam C10",  "ChiSquareSireMgs C10",  "ChiSquareSireDam C10",  "Howard1b C10",  "Howard1c C10",
       "VR1 C20",  "VR2BernoulliSireMgs C20",  "VR2BernoulliSireDam C20",  "ChiSquareSireMgs C20",  "ChiSquareSireDam C20",  "Howard1b C20",  "Howard1c C20",
       "VR1 C50",  "VR2BernoulliSireMgs C50",  "VR2BernoulliSireDam C50",  "ChiSquareSireMgs C50",  "ChiSquareSireDam C50",  "Howard1b C50",  "Howard1c C50",
       "VR1 C100", "VR2BernoulliSireMgs C100", "VR2BernoulliSireDam C100", "ChiSquareSireMgs C100", "ChiSquareSireDam C100", "Howard1b C100", "Howard1c C100"))


## Draw manhattan plot with different core lengths and different methods used
png(file=paste0("ManhattanVRBinomialChiSquareHoward1a1bAllCoresNotAnnotatet.png"), width=15, height=10, unit="in", res=200)
par(mar=c(5,5.5,4,2))
manhattan.plot(DataCumulative$Chromosome, DataCumulative$Region, DataCumulative$Pvalue, sig.level=5e-8, cex.lab=2, cex.axis=2)

png(file=paste0("ManhattanVRBinomialChiSquareHoward1a1bAllCoresAnnotated.png"), width=15, height=10, unit="in", res=200)
par(mar=c(5,5.5,4,2))
manhattan.plot(DataCumulative$Chromosome, DataCumulative$Region, DataCumulative$Pvalue, sig.level=5e-8, cex.lab=2, cex.axis=2,
        annotate=list(ann,
                           "VR1 C5"                   =list(col="#e41a1c", pch=21),
                           "VR2BernoulliSireMgs C5"   =list(col="#377eb8", pch=21),
                           "VR2BernoulliSireDam C5"   =list(col="#4daf4a", pch=21),
                           "ChiSquareSireMgs C5"      =list(col="#984ea3", pch=21),
                           "ChiSquareSireDam C5"      =list(col="#ff7f00", pch=21),
                           "Howard1b C5"              =list(col="#000000", pch=21),
                           "Howard1c C5"              =list(col="#a65628", pch=21),
                           "VR1 C10"                  =list(col="#e41a1c", pch=22),
                           "VR2BernoulliSireMgs C10"  =list(col="#377eb8", pch=22),
                           "VR2BernoulliSireDam C10"  =list(col="#4daf4a", pch=22),
                           "ChiSquareSireMgs C10"     =list(col="#984ea3", pch=22),
                           "ChiSquareSireDam C10"     =list(col="#ff7f00", pch=22),
                           "Howard1b C10"             =list(col="#000000", pch=22),
                           "Howard1c C10"             =list(col="#a65628", pch=22),
                           "VR1 C20"                  =list(col="#e41a1c", pch=23),
                           "VR2BernoulliSireMgs C20"  =list(col="#377eb8", pch=23),
                           "VR2BernoulliSireDam C20"  =list(col="#4daf4a", pch=23),
                           "ChiSquareSireMgs C20"     =list(col="#984ea3", pch=23),
                           "ChiSquareSireDam C20"     =list(col="#ff7f00", pch=23),
                           "Howard1b C20"             =list(col="#000000", pch=23),
                           "Howard1c C20"             =list(col="#a65628", pch=23),
                           "VR1 C50"                  =list(col="#e41a1c", pch=24),
                           "VR2BernoulliSireMgs C50"  =list(col="#377eb8", pch=24),
                           "VR2BernoulliSireDam C50"  =list(col="#4daf4a", pch=24),
                           "ChiSquareSireMgs C50"     =list(col="#984ea3", pch=24),
                           "ChiSquareSireDam C50"     =list(col="#ff7f00", pch=24),
                           "Howard1b C50"             =list(col="#000000", pch=24),
                           "Howard1c C50"             =list(col="#a65628", pch=24),
                           "VR1 C100"                 =list(col="#e41a1c", pch=25),
                           "VR2BernoulliSireMgs C100" =list(col="#377eb8", pch=25),
                           "VR2BernoulliSireDam C100" =list(col="#4daf4a", pch=25),
                           "ChiSquareSireMgs C100"    =list(col="#984ea3", pch=25),
                           "ChiSquareSireDam C100"    =list(col="#ff7f00", pch=25),
                           "Howard1b C100"            =list(col="#000000", pch=25),
                           "Howard1c C100"            =list(col="#a65628", pch=25)))
dev.off()

## Draw a plot where you show which significant haplotypes were in the animals for detemined for sequencing from the 4 approaches
DataCumulative$Approach1 <- "FALSE"
DataCumulative$Approach2 <- "FALSE"
DataCumulative$Approach3 <- "FALSE"
DataCumulative$Approach4 <- "FALSE"

DataCumulative$Approach1 <- paste(DataCumulative$Chromosome, DataCumulative$HaploLib, DataCumulative$CoreLength, DataCumulative$HaploID, DataCumulative$Method) %in% paste(HaploToSequenceApp1$Chromosome, HaploToSequenceApp1$HaploLib, HaploToSequenceApp1$CoreLength, HaploToSequenceApp1$HaploID, HaploToSequenceApp1$Method)
DataCumulative$Approach2 <- paste(DataCumulative$Chromosome, DataCumulative$HaploLib, DataCumulative$CoreLength, DataCumulative$HaploID, DataCumulative$Method) %in% paste(HaploToSequenceApp2$Chromosome, HaploToSequenceApp2$HaploLib, HaploToSequenceApp2$CoreLength, HaploToSequenceApp2$HaploID, HaploToSequenceApp2$Method)
DataCumulative$Approach3 <- paste(DataCumulative$Chromosome, DataCumulative$HaploLib, DataCumulative$CoreLength, DataCumulative$HaploID, DataCumulative$Method) %in% paste(HaploToSequenceApp3$Chromosome, HaploToSequenceApp3$HaploLib, HaploToSequenceApp3$CoreLength, HaploToSequenceApp3$HaploID, HaploToSequenceApp3$Method)
DataCumulative$Approach4 <- paste(DataCumulative$Chromosome, DataCumulative$HaploLib, DataCumulative$CoreLength, DataCumulative$HaploID, DataCumulative$Method) %in% paste(HaploToSequenceApp4$Chromosome, HaploToSequenceApp4$HaploLib, HaploToSequenceApp4$CoreLength, HaploToSequenceApp4$HaploID, HaploToSequenceApp4$Method)

ann                                                                                        <- rep(1, length(DataCumulative$Pvalue))
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength5")]                   <- 2
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength5")]   <- 3
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength5")]   <- 4
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength5")]      <- 5
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength5")]      <- 6
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength5")]              <- 7
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength5")]              <- 8
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength10")]                  <- 9
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength10")]  <- 10
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength10")]  <- 11
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength10")]     <- 12
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength10")]     <- 13
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength10")]             <- 14
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength10")]             <- 15
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength20")]                  <- 16
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength20")]  <- 17
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength20")]  <- 18
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength20")]     <- 19
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength20")]     <- 20
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength20")]             <- 21
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength20")]             <- 22
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength50")]                  <- 23
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength50")]  <- 24
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength50")]  <- 25
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength50")]     <- 26
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength50")]     <- 27
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength50")]             <- 28
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength50")]             <- 29
ann[with(DataCumulative, Method=="VR1.txt" & CoreLength=="CoreLength100")]                 <- 30
ann[with(DataCumulative, Method=="VR2BernoulliSireMgs.txt" & CoreLength=="CoreLength100")] <- 31
ann[with(DataCumulative, Method=="VR2BernoulliSireDam.txt" & CoreLength=="CoreLength100")] <- 32
ann[with(DataCumulative, Method=="ChiSquareSireMgs.txt" & CoreLength=="CoreLength100")]    <- 33
ann[with(DataCumulative, Method=="ChiSquareSireDam.txt" & CoreLength=="CoreLength100")]    <- 34
ann[with(DataCumulative, Method=="Howard1b.txt" & CoreLength=="CoreLength100")]            <- 35
ann[with(DataCumulative, Method=="Howard1c.txt" & CoreLength=="CoreLength100")]            <- 36
ann[with(DataCumulative, Approach4==TRUE)]                                                 <- 37
ann[with(DataCumulative, Approach3==TRUE)]                                                 <- 38
ann[with(DataCumulative, Approach2==TRUE)]                                                 <- 39
ann[with(DataCumulative, Approach1==TRUE)]                                                 <- 40
ann <- factor(ann, levels=1:40, labels=c("",
       "VR1 C5",   "VR2BernoulliSireMgs C5",   "VR2BernoulliSireDam C5",   "ChiSquareSireMgs C5",   "ChiSquareSireDam C5",   "Howard1b C5",   "Howard1c C5",
       "VR1 C10",  "VR2BernoulliSireMgs C10",  "VR2BernoulliSireDam C10",  "ChiSquareSireMgs C10",  "ChiSquareSireDam C10",  "Howard1b C10",  "Howard1c C10",
       "VR1 C20",  "VR2BernoulliSireMgs C20",  "VR2BernoulliSireDam C20",  "ChiSquareSireMgs C20",  "ChiSquareSireDam C20",  "Howard1b C20",  "Howard1c C20",
       "VR1 C50",  "VR2BernoulliSireMgs C50",  "VR2BernoulliSireDam C50",  "ChiSquareSireMgs C50",  "ChiSquareSireDam C50",  "Howard1b C50",  "Howard1c C50",
       "VR1 C100", "VR2BernoulliSireMgs C100", "VR2BernoulliSireDam C100", "ChiSquareSireMgs C100", "ChiSquareSireDam C100", "Howard1b C100", "Howard1c C100",
       "A4",       "A3",                       "A2",                       "A1"))


## Draw manhattan plot with different core lengths and different methods used
png(file=paste0("ManhattanVRBinomialChiSquareHoward1a1bAllCoresWithHaplotypesSequencesFromFourApproaches.png"), width=15, height=10, unit="in", res=200)
par(mar=c(5,5.5,4,2))
manhattan.plot(DataCumulative$Chromosome, DataCumulative$Region, DataCumulative$Pvalue, sig.level=5e-8, cex.lab=2, cex.axis=2,
        annotate=list(ann,
                           "VR1 C5"                   =list(col="#e41a1c", pch=21),
                           "VR2BernoulliSireMgs C5"   =list(col="#377eb8", pch=21),
                           "VR2BernoulliSireDam C5"   =list(col="#4daf4a", pch=21),
                           "ChiSquareSireMgs C5"      =list(col="#984ea3", pch=21),
                           "ChiSquareSireDam C5"      =list(col="#ff7f00", pch=21),
                           "Howard1b C5"              =list(col="#000000", pch=21),
                           "Howard1c C5"              =list(col="#a65628", pch=21),
                           "VR1 C10"                  =list(col="#e41a1c", pch=22),
                           "VR2BernoulliSireMgs C10"  =list(col="#377eb8", pch=22),
                           "VR2BernoulliSireDam C10"  =list(col="#4daf4a", pch=22),
                           "ChiSquareSireMgs C10"     =list(col="#984ea3", pch=22),
                           "ChiSquareSireDam C10"     =list(col="#ff7f00", pch=22),
                           "Howard1b C10"             =list(col="#000000", pch=22),
                           "Howard1c C10"             =list(col="#a65628", pch=22),
                           "VR1 C20"                  =list(col="#e41a1c", pch=23),
                           "VR2BernoulliSireMgs C20"  =list(col="#377eb8", pch=23),
                           "VR2BernoulliSireDam C20"  =list(col="#4daf4a", pch=23),
                           "ChiSquareSireMgs C20"     =list(col="#984ea3", pch=23),
                           "ChiSquareSireDam C20"     =list(col="#ff7f00", pch=23),
                           "Howard1b C20"             =list(col="#000000", pch=23),
                           "Howard1c C20"             =list(col="#a65628", pch=23),
                           "VR1 C50"                  =list(col="#e41a1c", pch=24),
                           "VR2BernoulliSireMgs C50"  =list(col="#377eb8", pch=24),
                           "VR2BernoulliSireDam C50"  =list(col="#4daf4a", pch=24),
                           "ChiSquareSireMgs C50"     =list(col="#984ea3", pch=24),
                           "ChiSquareSireDam C50"     =list(col="#ff7f00", pch=24),
                           "Howard1b C50"             =list(col="#000000", pch=24),
                           "Howard1c C50"             =list(col="#a65628", pch=24),
                           "VR1 C100"                 =list(col="#e41a1c", pch=25),
                           "VR2BernoulliSireMgs C100" =list(col="#377eb8", pch=25),
                           "VR2BernoulliSireDam C100" =list(col="#4daf4a", pch=25),
                           "ChiSquareSireMgs C100"    =list(col="#984ea3", pch=25),
                           "ChiSquareSireDam C100"    =list(col="#ff7f00", pch=25),
                           "Howard1b C100"            =list(col="#000000", pch=25),
                           "Howard1c C100"            =list(col="#a65628", pch=25),
                           "A4"                       =list(col="#feebe2", pch=16, cex=1.2),
                           "A3"                       =list(col="#fbb4b9", pch=16, cex=1.4),
                           "A2"                       =list(col="#f768a1", pch=16, cex=1.6),
                           "A1"                       =list(col="#ae017e", pch=16, cex=1.8)))
dev.off()


